<?php
/**
 * @version		1.0.0
 * @package		Joomla
 * @subpackage	OS Membership
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */

defined( '_JEXEC' ) or die ;

class plgOSMembershipJSProfileType extends JPlugin
{	
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		//JFactory::getLanguage()->load('plg_osmembership_jomsocial', JPATH_ADMINISTRATOR);			
		JTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_osmembership/tables');		
	}
	/**
	 * Render settings from
	 * @param PlanOSMembership $row
	 */
	function onEditSubscriptionPlan($row) {	
		ob_start();
			$this->_drawSettingForm($row);		
			$form = ob_get_contents();	
		ob_end_clean();		
		return array('title' => JText::_('JomSocial Profile Type Settings'),							
					'form' => $form
		) ;				
	}

	/**
	 * Store setting into database
	 * @param PlanOsMembership $row
	 * @param Boolean $isNew true if create new plan, false if edit
	 */
	function onAfterSaveSubscriptionPlan($row, $data,$isNew) {
		// $row of table osmembership_groups
		$params = new JRegistry($row->params);		
		$params->set('jomsocial_profile_id'			, $data['jomsocial_profile_id'][0] );
		$params->set('jomsocial_expried_profile_id'	, $data['jomsocial_expried_profile_id'][0]);		
		$row->params = $params->toString();
		
		$row->store();
	}
	/**
	 * Run when a membership activated
	 * @param PlanOsMembership $row
	 */		
	function onMembershipActive($row) {		
		if ($row->user_id) {
			$db = JFactory::getDbo() ;
			$sql = 'SELECT COUNT(*) FROM #__community_users WHERE userid='.$row->user_id ;
			$db->setQuery($sql);
			$count = $db->loadResult();			
			if (!$count) {
				return ;
			}
			
			$sql = 'SELECT profile_id FROM #__community_users WHERE userid='.$row->user_id ;
			$db->setQuery($sql);
			$profileTypeObj = $db->loadObject();
			if ($profileTypeObj->profile_id) {
				return ;
			}			
			$plan =  &JTable::getInstance('Osmembership','Plan');

			$plan->load($row->plan_id);
			$params = new JRegistry($plan->params);					
			$profileType = $params->get('jomsocial_profile_id');
			
			$sql = 'UPDATE #__community_users SET profile_id ='.$profileType.' WHERE userid='.$row->user_id;
			$db->setQuery($sql);
			$db->query();									
										
		}
		
		return true ;
	}
	/**
	 * Run when a membership expiried die
	 * @param PlanOsMembership $row
	 */		
	function onMembershipExpire($row) {
		if ($row->user_id) {
			$plan =  &JTable::getInstance('Osmembership','Plan');
			$plan->load($row->plan_id);
			$params = new JRegistry($plan->params);										$expriedProfile = $params->get('jomsocial_expried_profile_id');
			if ($expriedProfile) {
				$db = JFactory::getDbo() ;
				$sql = 'UPDATE #__community_users SET profile_id = 0 WHERE userid='.$row->user_id.' AND profile_id='.$expriedProfile;
				$db->setQuery($sql);
				$db->query();	 
			}		
		}		
	}
	/**
	 * Display form allows users to change setting for this subscription plan 
	 * @param object $row
	 * 
	 */	
	function _drawSettingForm($row) {
		// $row of table osmembership_plans
		$params = new JRegistry($row->params);		
		$jomsocial_profile_id 			= $params->get('jomsocial_profile_id', '');
		$jomsocial_expried_profile_id 	= $params->get('jomsocial_expried_profile_id', '');	

		$db = JFactory::getDbo() ;
		$sql = 'SELECT id, name FROM #__community_profiles WHERE published = 1 ORDER BY name ';
		$db->setQuery($sql);

		$options = array();
		$options[] = JHTML::_('select.option', 0, JText::_('Choose Profile Type'), 'id', 'name');
		$options = array_merge($options, $db->loadObjectList()) ;		
	?>	
		<table class="admintable adminform" style="width: 90%;">
				<tr>
					<td width="220" class="key">
						<?php echo  JText::_('Assign to JomSocial Profile Type'); ?>
					</td>
					<td>
						<?php
							echo JHTML::_('select.genericlist', $options, 'jomsocial_profile_id[]', ' multiple="multiple" size="6" ', 'id', 'name', $jomsocial_profile_id); 							
						?>
					</td>
					<td>
						<?php echo JText::_('Choose the Jomsocial Profile Type you want to assign users to when they subscribe to this subscription plan '); ?>
					</td>
				</tr>
				<tr>
					<td width="220" class="key">
						<?php echo  JText::_('Remove from Jomsocial Profile Type'); ?>
					</td>
					<td>
						<?php
							echo JHTML::_('select.genericlist', $options, 'jomsocial_expried_profile_id[]', ' multiple="multiple" size="6" ', 'id', 'name', $jomsocial_expried_profile_id);
						?>						
					</td>
					<td>
						<?php echo JText::_(' Choose the Profile Type you want to remove users from when their subscription for this plan expired '); ?>
					</td>
				</tr>	
		</table>	
	<?php							
	}
}	